SystemOrganization addCategory: #'Orca-Tools'!
SystemOrganization addCategory: #'Orca-Tools-Tests'!

Model subclass: #OrcaControlPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

!OrcaControlPanel commentStamp: 'sw 4/12/2011 10:35' prior: 0!
I am a configuration panel for the Orca Webframework.

I can set swazooDebug ->  Smalltalk at: #OrcaDebugSwazooInternalErrors

Default: the print messages are disabled.
in Smalltalk -> see updatesKey.

OrcaTranslatedClass disablePrintUpdates 
OrcaTranslatedMethod disablePrintUpdates 


entweder cacheCodeFor:  producedBy: 
	speicher state
	set on
	work
	reset state
	
oder in codeForClasses: !

!OrcaControlPanel class methodsFor: 'open' stamp: 'sw 4/12/2011 18:17'!
open

	^ToolBuilder open: self! !

!OrcaControlPanel class methodsFor: 'configuration' stamp: 'sw 4/12/2011 16:54'!
sizeOfCheckBoxes

	^ 0.8@ 0.08! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 18:17'!
buildWith: builder

	| windowSpec buttonSpec optionSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec extent: 500@400.
	windowSpec model: self.
	windowSpec label: self class name asString.
	windowSpec children: OrderedCollection new.
	
	optionSpec := builder pluggableCheckBoxSpec new.
	optionSpec
		model: self;
		label: #labelDebugSwazooMessages;
		state: #debugSwazooMessages;
		action: #changeDebugSwazooMessages;
		color: #runButtonColor;
		frame: (0.1 @ 0.01 extent: self class sizeOfCheckBoxes ).
	windowSpec children add: optionSpec.
	
	optionSpec := builder pluggableCheckBoxSpec new.
	optionSpec
		model: self;
		label: #labelShowCompilingNotification;
		state: #showCompilingNotification;
		action: #changeShowCompilingNotification;
		color: #runButtonColor;
		frame: (0.1 @ 0.09 extent: self class sizeOfCheckBoxes ).
	windowSpec children add: optionSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'clear cache';
		color: #runButtonColor;
		action: #clearCache;
		frame: (0.1 @ 0.9 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'forced restart';
		color: #runButtonColor;
		action: #forcedRestart;
		frame: (0.4 @ 0.9 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.


	
	
	^builder build: windowSpec
! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 15:42'!
changeDebugSwazooMessages

	Smalltalk at: #OrcaDebugSwazooInternalErrors put:
		((Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [false ]) not)! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 16:47'!
changeShowCompilingNotification

	Smalltalk at: #OrcaShowCompilingNotification put:
		((Smalltalk at: #OrcaShowCompilingNotification ifAbsent: [false ]) not)! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 16:21'!
clearCache

	OrcaCodeFactory clearCache.
	OrcaPrettyCodeFactory clearCache.! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 15:42'!
debugSwazooMessages

	^ Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [false ]! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 16:37'!
forcedRestart

	OrcaDispatcher forcedRestart.! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 15:43'!
labelDebugSwazooMessages

	 ^ 'Show debug Swazoo Messages'! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 16:50'!
labelShowCompilingNotification

	 ^ 'Show Compiling Notification'! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 14:35'!
runButtonColor
	
	^ Color green! !

!OrcaControlPanel methodsFor: 'as yet unclassified' stamp: 'sw 4/12/2011 16:50'!
showCompilingNotification

	^ Smalltalk at: #OrcaShowCompilingNotification ifAbsent: [false ]! !

TestCase subclass: #OrcaControlPanelTest
	instanceVariableNames: 'panel originalStateOfDebugSwazooMessages originalStateOfShowCompilingNotification prettyCache origCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools-Tests'!

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:45'!
model
	
	^ self panel model! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
origCache
	^ origCache! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
origCache: anObject
	origCache := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages
	^ originalStateOfDebugSwazooMessages! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 15:46'!
originalStateOfDebugSwazooMessages: anObject
	originalStateOfDebugSwazooMessages := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification
	^ originalStateOfShowCompilingNotification! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:59'!
originalStateOfShowCompilingNotification: anObject
	originalStateOfShowCompilingNotification := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel
	^ panel! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 14:19'!
panel: anObject
	panel := anObject! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
prettyCache
	^ prettyCache! !

!OrcaControlPanelTest methodsFor: 'accessing' stamp: 'sw 4/12/2011 16:24'!
prettyCache: anObject
	prettyCache := anObject! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'sw 4/12/2011 17:00'!
setUp 

	self panel: (OrcaControlPanel open).
	self originalStateOfDebugSwazooMessages: (Smalltalk at: #OrcaDebugSwazooInternalErrors ifAbsent: [ false ]).
	Smalltalk removeKey: #OrcaDebugSwazooInternalErrors ifAbsent: [].
	self originalStateOfShowCompilingNotification: (Smalltalk at: #OrcaShowCompilingNotification ifAbsent: [ false ]).
	Smalltalk removeKey: #OrcaShowCompilingNotification ifAbsent: [].
	
	self origCache: OrcaCodeFactory codeCache.
	self prettyCache: OrcaPrettyCodeFactory codeCache.! !

!OrcaControlPanelTest methodsFor: 'running' stamp: 'sw 4/12/2011 17:01'!
tearDown 

	self panel delete.
	Smalltalk at: #OrcaDebugSwazooInternalErrors put: self originalStateOfDebugSwazooMessages.
	Smalltalk at: #OrcaShowCompilingNotification put: self originalStateOfShowCompilingNotification.
		
	OrcaCodeFactory codeCache: self origCache.
	OrcaPrettyCodeFactory codeCache: self prettyCache.
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 14:29'!
testBuildSystemWindow

	self assert: ( self panel class == PluggableSystemWindow)! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 16:22'!
testClearCache

	self model clearCache.
	self assert: ( OrcaPrettyCodeFactory codeCache isEmpty).
	self assert: ( OrcaCodeFactory codeCache  isEmpty).
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 15:56'!
testToggleDebugSwazooMessages

	| oldState newState |
	oldState := self model debugSwazooMessages.
	self model changeDebugSwazooMessages.
	newState := self model debugSwazooMessages.
	self assert: ( oldState == (newState not)).
	
	
	! !

!OrcaControlPanelTest methodsFor: 'testing' stamp: 'sw 4/12/2011 17:03'!
testToggleShowCompilingNotification

	| oldState newState |
	oldState := self model showCompilingNotification.
	self model changeShowCompilingNotification.
	newState := self model showCompilingNotification.
	
	self assert: ( oldState == (newState not)).
	
	
	! !

Morph subclass: #OrcaCompilingNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tools'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

OrcaCompilingNotification class
	instanceVariableNames: 'singleton'!

!OrcaCompilingNotification class methodsFor: 'accessing' stamp: 'sw 4/12/2011 18:35'!
hide

	self singleton delete! !

!OrcaCompilingNotification class methodsFor: 'accessing' stamp: 'sw 4/12/2011 18:34'!
isVisible
	
	^ (self singleton owner isNil not)! !

!OrcaCompilingNotification class methodsFor: 'accessing' stamp: 'sw 4/12/2011 18:36'!
show

	self singleton openInWorld! !

!OrcaCompilingNotification class methodsFor: 'accessing' stamp: 'sw 4/12/2011 18:34'!
singleton
	
	singleton ifNil: 
		[ self singleton: (self new setProperties)].
	
	^ singleton! !

!OrcaCompilingNotification class methodsFor: 'accessing' stamp: 'sw 4/12/2011 18:30'!
singleton: anObject
	singleton := anObject! !

!OrcaCompilingNotification methodsFor: 'configuration' stamp: 'sw 4/12/2011 18:29'!
setProperties
	| t |
	
	t := TextMorph new
		contents:'Orca is compiling';
  		position: 75@150;
  		color: Color white.

		self color: Color blue;
			position: 50@50;
			extent: 160@120;
			addMorph: t;
			openInWorld.! !
